#ifndef specialfunctions_interface_h
#define specialfunctions_interface_h

#include "fcomplex.h"

extern "C"
{
  void ch12n_ (int &n, fcomplex &z, int &nm, fcomplex *chf1, fcomplex *chd1, fcomplex *chf2, fcomplex *chd2 );
  void cjynb_ (int &n, fcomplex &z, int &nm, fcomplex *cbj, fcomplex *cdj, fcomplex *cby, fcomplex *cdy );
  void jyzo_ (int &n, int &nt, double *rj0, double *rj1, double *ry0, double *ry1);
  void gamma_ (double &x, double &ga);
  void beta_ (double &p, double& q, double &bt);
  fcomplex ebeta_ (fcomplex &z1, fcomplex& z2);
}

inline double gamma_euler(double x)
{
  double ga;
  gamma_(x,ga);
  return ga;
}

inline double beta_euler(double a, double b)
{
  double bt;
  beta_(a,b,bt);
  return bt;
}

inline complex<double> beta_complex(complex <double> a, complex <double> b)
{
  fcomplex z1 = fcx(a);
  fcomplex z2 = fcx(b);
  return cx(ebeta_(z1,z2));
}

#endif
