cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       Implmentation of the Three-Loop Splitting Function
c       Pgg(3)
c       Normalization (as/Pi)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function Pgg3reg(z)
      implicit none
      include 'types.f'
      include 'nf.f'
      include 'constants.f'
      include 'HPLsinclude.f' 
      include 'HPLsinclude_w5.f' 
      include 'HPLsinclude_Basis_4.f'
      include 'HPLsinclude_Basis_5.f'
      real(dp):: Pgg3reg,z,Zeta
      external Zeta
      
      Pgg3reg =         -845.125 + (251*Nf)/96. + (283*Nf**2)/864. + (183*Pi**2)/8. - (1385*Nf*Pi**2)/864. + (11*Nf**2*Pi**2)/324. - (51*Pi**4)/16. + 
     -  (1693*Nf*Pi**4)/25920. + 73091/(96.*z) + (6077*Nf)/(648.*z) - (85*Nf**2)/(1944.*z) - (389*Pi**2)/(16.*z) - (8*Nf*Pi**2)/(27.*z) - 
     -  (87*Pi**4)/(80.*z) + (24839*z)/32. + (35059*Nf*z)/864. + (317*Nf**2*z)/864. - (329*Pi**2*z)/16. - (581*Nf*Pi**2*z)/2592. + 
     -  (17*Nf**2*Pi**2*z)/324. - (27*Pi**4*z)/10. + (167*Nf*Pi**4*z)/2880. - (73091*z**2)/96. - (29759*Nf*z**2)/648. - (1211*Nf**2*z**2)/1944. + 
     -  (67*Pi**2*z**2)/8. - (1075*Nf*Pi**2*z**2)/648. - (Nf**2*Pi**2*z**2)/81. - (39*Pi**4*z**2)/40. - (67*Pi**2)/(8.*(1 + z)) + 
     -  (5*Nf*Pi**2)/(12.*(1 + z)) + (33*Pi**4)/(32.*(1 + z)) + (93*H1h(z))/16. + (5399*Nf*H1h(z))/864. - (175*Nf**2*H1h(z))/288. - 
     -  (27*Pi**2*H1h(z))/16. - (47*Nf*Pi**2*H1h(z))/432. - (413*H1h(z))/(16.*z) + (257*Nf*H1h(z))/(432.*z) + (11*Nf**2*H1h(z))/(648.*z) - 
     -  (99*Pi**2*H1h(z))/(16.*z) - (19*Nf*Pi**2*H1h(z))/(648.*z) - (93*z*H1h(z))/16. - (1135*Nf*z*H1h(z))/864. + (79*Nf**2*z*H1h(z))/288. + 
     -  (27*Pi**2*z*H1h(z))/16. + (47*Nf*Pi**2*z*H1h(z))/432. + (413*z**2*H1h(z))/16. - (2389*Nf*z**2*H1h(z))/432. + (205*Nf**2*z**2*H1h(z))/648. + 
     -  (99*Pi**2*z**2*H1h(z))/16. + (19*Nf*Pi**2*z**2*H1h(z))/648. + (53*Nf*H1h(z)**2)/216. - (Nf**2*H1h(z)**2)/36. - (13*Nf*H1h(z)**2)/(54.*z) - 
     -  (Nf**2*H1h(z)**2)/(27.*z) - (53*Nf*z*H1h(z)**2)/216. + (Nf**2*z*H1h(z)**2)/36. + (13*Nf*z**2*H1h(z)**2)/54. + (Nf**2*z**2*H1h(z)**2)/27. - 
     -  (5*Nf*H1h(z)**3)/54. - (10*Nf*H1h(z)**3)/(81.*z) + (5*Nf*z*H1h(z)**3)/54. + (10*Nf*z**2*H1h(z)**3)/81. - (Nf*H21(z))/18. - (Nf**2*H21(z))/9. - 
     -  (38*Nf*H21(z))/(27.*z) + (29*Nf*z*H21(z))/18. - (Nf**2*z*H21(z))/9. + (22*Nf*z**2*H21(z))/27. + (10*Nf*H22(z))/9. + (10*Nf*z*H22(z))/9. - 
     -  (219*H2h(z))/8. + (1903*Nf*H2h(z))/432. - (5*Nf**2*H2h(z))/54. - (27*Pi**2*H2h(z))/2. - (19*Nf*Pi**2*H2h(z))/216. + (25*Nf*H2h(z))/(54.*z) + 
     -  (4*Nf**2*H2h(z))/(27.*z) - (219*z*H2h(z))/8. + (3467*Nf*z*H2h(z))/432. - (23*Nf**2*z*H2h(z))/54. - (9*Pi**2*z*H2h(z))/2. - 
     -  (19*Nf*Pi**2*z*H2h(z))/216. - (131*Nf*z**2*H2h(z))/54. - (2*Nf**2*z**2*H2h(z))/27. - (9*Pi**2*z**2*H2h(z))/2. + 
     -  (9*Pi**2*H2h(z))/(4.*(1 + z)) + (5*Nf*H1h(z)*H2h(z))/9. + (20*Nf*H1h(z)*H2h(z))/(27.*z) - (5*Nf*z*H1h(z)*H2h(z))/9. - 
     -  (20*Nf*z**2*H1h(z)*H2h(z))/27. + 54*H2m2(z) - (27*H2m2(z))/z - 27*z*H2m2(z) + 27*z**2*H2m2(z) - (495*H3h(z))/4. + (409*Nf*H3h(z))/72. + 
     -  (2*Nf**2*H3h(z))/9. + (99*H3h(z))/(4.*z) + (8*Nf*H3h(z))/(27.*z) - (279*z*H3h(z))/4. + (25*Nf*z*H3h(z))/24. + (2*Nf**2*z*H3h(z))/9. - 
     -  99*z**2*H3h(z) + (49*Nf*z**2*H3h(z))/18. + 108*H3m1(z) - (54*H3m1(z))/z - 54*z*H3m1(z) + 54*z**2*H3m1(z) + 27*HB0001(z) + 
     -  (29*Nf*HB0001(z))/18. - (27*HB0001(z))/(2.*z) + (81*z*HB0001(z))/2. + (29*Nf*z*HB0001(z))/18. - (27*z**2*HB0001(z))/2. + 
     -  (27*HB0001(z))/(2.*(1 + z)) + (5*Nf*HB0011(z))/3. + (5*Nf*z*HB0011(z))/3. - (10*Nf*HB0111(z))/9. - (10*Nf*z*HB0111(z))/9. + 108*HBm1001(z) + 
     -  (54*HBm1001(z))/z + 54*z*HBm1001(z) + 54*z**2*HBm1001(z) - (54*HBm1001(z))/(1 + z) - 216*HBm1m101(z) - (108*HBm1m101(z))/z - 
     -  108*z*HBm1m101(z) - 108*z**2*HBm1m101(z) + (108*HBm1m101(z))/(1 + z) - (477*Pi**2*Hm1(z))/16. - (83*Nf*Pi**2*Hm1(z))/432. - 
     -  (99*Pi**2*Hm1(z))/(16.*z) + (Nf*Pi**2*Hm1(z))/(648.*z) - (477*Pi**2*z*Hm1(z))/16. - (83*Nf*Pi**2*z*Hm1(z))/432. - (99*Pi**2*z**2*Hm1(z))/16. + 
     -  (Nf*Pi**2*z**2*Hm1(z))/648. + (675*Hm12(z))/4. + (Nf*Hm12(z))/2. + (297*Hm12(z))/(4.*z) + (Nf*Hm12(z))/(6.*z) + (675*z*Hm12(z))/4. + 
     -  (Nf*z*Hm12(z))/2. + (297*z**2*Hm12(z))/4. + (Nf*z**2*Hm12(z))/6. + 36*Pi**2*Hm1m1(z) + (18*Pi**2*Hm1m1(z))/z + 18*Pi**2*z*Hm1m1(z) + 
     -  18*Pi**2*z**2*Hm1m1(z) - (18*Pi**2*Hm1m1(z))/(1 + z) + (81*Hm1m2(z))/4. + (47*Nf*Hm1m2(z))/36. - (297*Hm1m2(z))/(4.*z) - 
     -  (19*Nf*Hm1m2(z))/(54.*z) + (81*z*Hm1m2(z))/4. + (47*Nf*z*Hm1m2(z))/36. - (297*z**2*Hm1m2(z))/4. - (19*Nf*z**2*Hm1m2(z))/54. - 108*Hm1m3(z) - 
     -  (54*Hm1m3(z))/z - 54*z*Hm1m3(z) - 54*z**2*Hm1m3(z) + (54*Hm1m3(z))/(1 + z) + (327*Hm2(z))/8. - (677*Nf*Hm2(z))/216. - (27*Pi**2*Hm2(z))/2. - 
     -  (19*Nf*Pi**2*Hm2(z))/216. + (765*Hm2(z))/(8.*z) + (337*Nf*Hm2(z))/(36.*z) + (9*Pi**2*Hm2(z))/z + (1131*z*Hm2(z))/8. - (461*Nf*z*Hm2(z))/216. + 
     -  (27*Pi**2*z*Hm2(z))/2. + (19*Nf*Pi**2*z*Hm2(z))/216. + (765*z**2*Hm2(z))/8. + (553*Nf*z**2*Hm2(z))/36. - (9*Pi**2*z**2*Hm2(z))/2. + 
     -  (201*Hm2(z))/(2.*(1 + z)) - (5*Nf*Hm2(z))/(1 + z) - (9*Pi**2*Hm2(z))/(4.*(1 + z)) + 162*Hm22(z) + (27*Hm22(z))/z + 27*z*Hm22(z) + 
     -  81*z**2*Hm22(z) - (54*Hm22(z))/(1 + z) + (81*Hm2m1(z))/4. + (47*Nf*Hm2m1(z))/36. - (297*Hm2m1(z))/(4.*z) - (19*Nf*Hm2m1(z))/(54.*z) + 
     -  (81*z*Hm2m1(z))/4. + (47*Nf*z*Hm2m1(z))/36. - (297*z**2*Hm2m1(z))/4. - (19*Nf*z**2*Hm2m1(z))/54. + (19*Nf*Hm2m2(z))/18. - (81*Hm2m2(z))/z - 
     -  135*z*Hm2m2(z) - (19*Nf*z*Hm2m2(z))/18. - 27*z**2*Hm2m2(z) + (54*Hm2m2(z))/(1 + z) + (153*Hm3(z))/2. - (467*Nf*Hm3(z))/24. + 
     -  (495*Hm3(z))/(2.*z) - (131*Nf*Hm3(z))/(54.*z) + (243*z*Hm3(z))/2. + (1703*Nf*z*Hm3(z))/72. - 99*z**2*Hm3(z) - (43*Nf*z**2*Hm3(z))/18. - 
     -  108*H1h(z)*Hm3(z) + (54*H1h(z)*Hm3(z))/z + 54*z*H1h(z)*Hm3(z) - 54*z**2*H1h(z)*Hm3(z) + 108*Hm31(z) - (54*Hm31(z))/z - 54*z*Hm31(z) + 
     -  54*z**2*Hm31(z) + 108*Hm3m1(z) + (19*Nf*Hm3m1(z))/9. - (108*Hm3m1(z))/z - 216*z*Hm3m1(z) - (19*Nf*z*Hm3m1(z))/9. + (54*Hm3m1(z))/(1 + z) + 
     -  513*Hm4(z) - (41*Nf*Hm4(z))/6. + (351*Hm4(z))/(2.*z) + (675*z*Hm4(z))/2. - (41*Nf*z*Hm4(z))/6. + (351*z**2*Hm4(z))/2. - 
     -  (351*Hm4(z))/(2.*(1 + z)) + (15397*Ho(z))/32. + (2123*Nf*Ho(z))/54. - (5*Nf**2*Ho(z))/648. + (555*Pi**2*Ho(z))/16. + 
     -  (421*Nf*Pi**2*Ho(z))/864. + (Nf**2*Pi**2*Ho(z))/27. + (9*Ho(z))/(8.*(1 - z)) - (3*Nf*Ho(z))/(8.*(1 - z)) + (395*Ho(z))/(4.*z) + 
     -  (295*Nf*Ho(z))/(108.*z) - (33*Pi**2*Ho(z))/(8.*z) - (Nf*Pi**2*Ho(z))/(36.*z) + (4687*z*Ho(z))/32. + (1141*Nf*z*Ho(z))/864. + 
     -  (2563*Nf**2*z*Ho(z))/2592. + (69*Pi**2*z*Ho(z))/4. - (199*Nf*Pi**2*z*Ho(z))/864. + (Nf**2*Pi**2*z*Ho(z))/27. + (7953*z**2*Ho(z))/16. + 
     -  (797*Nf*z**2*Ho(z))/16. + (205*Nf**2*z**2*Ho(z))/648. + (363*Pi**2*z**2*Ho(z))/8. - (Nf*Pi**2*z**2*Ho(z))/12. - 
     -  (33*Pi**2*Ho(z))/(16.*(1 + z)) + (Nf*Pi**2*Ho(z))/(8.*(1 + z)) - (879*H1h(z)*Ho(z))/8. + (563*Nf*H1h(z)*Ho(z))/108. - 
     -  (Nf**2*H1h(z)*Ho(z))/9. + (27*Pi**2*H1h(z)*Ho(z))/2. + (201*H1h(z)*Ho(z))/(2.*(1 - z)) - (5*Nf*H1h(z)*Ho(z))/(1 - z) - 
     -  (27*Pi**2*H1h(z)*Ho(z))/(4.*(1 - z)) + (201*H1h(z)*Ho(z))/(4.*z) - (869*Nf*H1h(z)*Ho(z))/(108.*z) - (4*Nf**2*H1h(z)*Ho(z))/(27.*z) - 
     -  (27*Pi**2*H1h(z)*Ho(z))/(4.*z) + (75*z*H1h(z)*Ho(z))/8. - (491*Nf*z*H1h(z)*Ho(z))/108. + (Nf**2*z*H1h(z)*Ho(z))/9. - 
     -  (27*Pi**2*z*H1h(z)*Ho(z))/4. - (201*z**2*H1h(z)*Ho(z))/4. + (1337*Nf*z**2*H1h(z)*Ho(z))/108. + (4*Nf**2*z**2*H1h(z)*Ho(z))/27. + 
     -  (27*Pi**2*z**2*H1h(z)*Ho(z))/4. - (5*Nf*H1h(z)**2*Ho(z))/18. - (10*Nf*H1h(z)**2*Ho(z))/(27.*z) + (5*Nf*z*H1h(z)**2*Ho(z))/18. + 
     -  (10*Nf*z**2*H1h(z)**2*Ho(z))/27. - (10*Nf*H21(z)*Ho(z))/9. - (10*Nf*z*H21(z)*Ho(z))/9. + (99*H2h(z)*Ho(z))/8. - (655*Nf*H2h(z)*Ho(z))/144. - 
     -  (2*Nf**2*H2h(z)*Ho(z))/9. - (99*H2h(z)*Ho(z))/(8.*(1 - z)) + (3*Nf*H2h(z)*Ho(z))/(4.*(1 - z)) - (297*H2h(z)*Ho(z))/(4.*z) + 
     -  (28*Nf*H2h(z)*Ho(z))/(27.*z) - (63*z*H2h(z)*Ho(z))/2. - (247*Nf*z*H2h(z)*Ho(z))/48. - (2*Nf**2*z*H2h(z)*Ho(z))/9. - 
     -  (99*z**2*H2h(z)*Ho(z))/4. - (62*Nf*z**2*H2h(z)*Ho(z))/27. - 54*H2m1(z)*Ho(z) + (27*H2m1(z)*Ho(z))/(1 - z) + (27*H2m1(z)*Ho(z))/z + 
     -  27*z*H2m1(z)*Ho(z) - 27*z**2*H2m1(z)*Ho(z) - 27*H3h(z)*Ho(z) + (7*Nf*H3h(z)*Ho(z))/12. - (27*H3h(z)*Ho(z))/(2.*(1 - z)) - 
     -  (27*H3h(z)*Ho(z))/z - 54*z*H3h(z)*Ho(z) + (7*Nf*z*H3h(z)*Ho(z))/12. + (27*H3h(z)*Ho(z))/(2.*(1 + z)) - (327*Hm1(z)*Ho(z))/8. + 
     -  (677*Nf*Hm1(z)*Ho(z))/216. - (81*Pi**2*Hm1(z)*Ho(z))/2. - (765*Hm1(z)*Ho(z))/(8.*z) - (337*Nf*Hm1(z)*Ho(z))/(36.*z) - 
     -  (81*Pi**2*Hm1(z)*Ho(z))/(4.*z) - (1131*z*Hm1(z)*Ho(z))/8. + (461*Nf*z*Hm1(z)*Ho(z))/216. - (81*Pi**2*z*Hm1(z)*Ho(z))/4. - 
     -  (765*z**2*Hm1(z)*Ho(z))/8. - (553*Nf*z**2*Hm1(z)*Ho(z))/36. - (81*Pi**2*z**2*Hm1(z)*Ho(z))/4. - (201*Hm1(z)*Ho(z))/(2.*(1 + z)) + 
     -  (5*Nf*Hm1(z)*Ho(z))/(1 + z) + (81*Pi**2*Hm1(z)*Ho(z))/(4.*(1 + z)) + 54*Hm12(z)*Ho(z) + (27*Hm12(z)*Ho(z))/z + 27*z*Hm12(z)*Ho(z) + 
     -  27*z**2*Hm12(z)*Ho(z) - (27*Hm12(z)*Ho(z))/(1 + z) - (81*Hm1m1(z)*Ho(z))/4. - (47*Nf*Hm1m1(z)*Ho(z))/36. + (297*Hm1m1(z)*Ho(z))/(4.*z) + 
     -  (19*Nf*Hm1m1(z)*Ho(z))/(54.*z) - (81*z*Hm1m1(z)*Ho(z))/4. - (47*Nf*z*Hm1m1(z)*Ho(z))/36. + (297*z**2*Hm1m1(z)*Ho(z))/4. + 
     -  (19*Nf*z**2*Hm1m1(z)*Ho(z))/54. + 216*Hm1m2(z)*Ho(z) + (108*Hm1m2(z)*Ho(z))/z + 108*z*Hm1m2(z)*Ho(z) + 108*z**2*Hm1m2(z)*Ho(z) - 
     -  (108*Hm1m2(z)*Ho(z))/(1 + z) - (333*Hm2(z)*Ho(z))/2. + (149*Nf*Hm2(z)*Ho(z))/18. + (99*Hm2(z)*Ho(z))/(4.*(1 - z)) - 
     -  (3*Nf*Hm2(z)*Ho(z))/(2.*(1 - z)) - (891*Hm2(z)*Ho(z))/(4.*z) + (70*Nf*Hm2(z)*Ho(z))/(27.*z) - 189*z*Hm2(z)*Ho(z) - 
     -  (239*Nf*z*Hm2(z)*Ho(z))/18. - (99*z**2*Hm2(z)*Ho(z))/2. + (139*Nf*z**2*Hm2(z)*Ho(z))/54. + 54*H1h(z)*Hm2(z)*Ho(z) - 
     -  (27*H1h(z)*Hm2(z)*Ho(z))/(1 - z) - (27*H1h(z)*Hm2(z)*Ho(z))/z - 27*z*H1h(z)*Hm2(z)*Ho(z) + 27*z**2*H1h(z)*Hm2(z)*Ho(z) - 54*Hm21(z)*Ho(z) + 
     -  (27*Hm21(z)*Ho(z))/(1 - z) + (27*Hm21(z)*Ho(z))/z + 27*z*Hm21(z)*Ho(z) - 27*z**2*Hm21(z)*Ho(z) + 108*Hm2m1(z)*Ho(z) - 
     -  (19*Nf*Hm2m1(z)*Ho(z))/18. + (27*Hm2m1(z)*Ho(z))/(1 - z) + (135*Hm2m1(z)*Ho(z))/z + 189*z*Hm2m1(z)*Ho(z) + (19*Nf*z*Hm2m1(z)*Ho(z))/18. + 
     -  81*z**2*Hm2m1(z)*Ho(z) - (108*Hm2m1(z)*Ho(z))/(1 + z) - 243*Hm3(z)*Ho(z) - (9*Nf*Hm3(z)*Ho(z))/4. + (27*Hm3(z)*Ho(z))/(1 - z) - 
     -  (81*Hm3(z)*Ho(z))/z - 216*z*Hm3(z)*Ho(z) + (245*Nf*z*Hm3(z)*Ho(z))/36. - 135*z**2*Hm3(z)*Ho(z) + (108*Hm3(z)*Ho(z))/(1 + z) - 
     -  (8715*Ho(z)**2)/32. + (1171*Nf*Ho(z)**2)/108. + (37*Nf**2*Ho(z)**2)/216. + (27*Pi**2*Ho(z)**2)/8. + (253*Nf*Pi**2*Ho(z)**2)/864. + 
     -  (201*Ho(z)**2)/(8.*(1 - z)) - (5*Nf*Ho(z)**2)/(4.*(1 - z)) - (9*Pi**2*Ho(z)**2)/(2.*(1 - z)) + (2367*z*Ho(z)**2)/32. - 
     -  (2197*Nf*z*Ho(z)**2)/288. + (49*Nf**2*z*Ho(z)**2)/216. - (99*Pi**2*z*Ho(z)**2)/8. + (91*Nf*Pi**2*z*Ho(z)**2)/864. - (4551*z**2*Ho(z)**2)/16. + 
     -  (1823*Nf*z**2*Ho(z)**2)/216. + (2*Nf**2*z**2*Ho(z)**2)/27. + 9*Pi**2*z**2*Ho(z)**2 + (201*Ho(z)**2)/(8.*(1 + z)) - 
     -  (5*Nf*Ho(z)**2)/(4.*(1 + z)) - (9*Pi**2*Ho(z)**2)/(2.*(1 + z)) - (873*H1h(z)*Ho(z)**2)/16. + (71*Nf*H1h(z)*Ho(z)**2)/288. + 
     -  (99*H1h(z)*Ho(z)**2)/(16.*(1 - z)) - (3*Nf*H1h(z)*Ho(z)**2)/(8.*(1 - z)) + (495*H1h(z)*Ho(z)**2)/(8.*z) - (32*Nf*H1h(z)*Ho(z)**2)/(27.*z) + 
     -  (387*z*H1h(z)*Ho(z)**2)/8. + (37*Nf*z*H1h(z)*Ho(z)**2)/288. - (495*z**2*H1h(z)*Ho(z)**2)/8. + (32*Nf*z**2*H1h(z)*Ho(z)**2)/27. - 
     -  27*H1h(z)**2*Ho(z)**2 + (27*H1h(z)**2*Ho(z)**2)/(2.*(1 - z)) + (27*H1h(z)**2*Ho(z)**2)/(2.*z) + (27*z*H1h(z)**2*Ho(z)**2)/2. - 
     -  (27*z**2*H1h(z)**2*Ho(z)**2)/2. + (81*H2h(z)*Ho(z)**2)/4. - (55*Nf*H2h(z)*Ho(z)**2)/48. + (27*H2h(z)*Ho(z)**2)/(4.*(1 - z)) + 
     -  (27*H2h(z)*Ho(z)**2)/(4.*z) + (81*z*H2h(z)*Ho(z)**2)/2. - (55*Nf*z*H2h(z)*Ho(z)**2)/48. - (27*z**2*H2h(z)*Ho(z)**2)/4. + 
     -  (513*Hm1(z)*Ho(z)**2)/4. + (209*Nf*Hm1(z)*Ho(z)**2)/144. + (99*Hm1(z)*Ho(z)**2)/z - (149*Nf*Hm1(z)*Ho(z)**2)/(108.*z) + 
     -  (513*z*Hm1(z)*Ho(z)**2)/4. + (209*Nf*z*Hm1(z)*Ho(z)**2)/144. + 99*z**2*Hm1(z)*Ho(z)**2 - (149*Nf*z**2*Hm1(z)*Ho(z)**2)/108. - 
     -  162*Hm1m1(z)*Ho(z)**2 - (81*Hm1m1(z)*Ho(z)**2)/z - 81*z*Hm1m1(z)*Ho(z)**2 - 81*z**2*Hm1m1(z)*Ho(z)**2 + (81*Hm1m1(z)*Ho(z)**2)/(1 + z) + 
     -  (163*Nf*Hm2(z)*Ho(z)**2)/72. - (27*Hm2(z)*Ho(z)**2)/(2.*(1 - z)) - (27*Hm2(z)*Ho(z)**2)/(4.*z) + (135*z*Hm2(z)*Ho(z)**2)/4. - 
     -  (163*Nf*z*Hm2(z)*Ho(z)**2)/72. + (81*z**2*Hm2(z)*Ho(z)**2)/4. - (27*Hm2(z)*Ho(z)**2)/(4.*(1 + z)) - (207*Ho(z)**3)/8. + (13*Nf*Ho(z)**3)/9. - 
     -  (Nf**2*Ho(z)**3)/54. + (87*z*Ho(z)**3)/8. - (1529*Nf*z*Ho(z)**3)/432. - (Nf**2*z*Ho(z)**3)/54. - (99*z**2*Ho(z)**3)/2. + 
     -  (4*Nf*z**2*Ho(z)**3)/81. - 18*H1h(z)*Ho(z)**3 + (9*H1h(z)*Ho(z)**3)/(1 - z) + (9*H1h(z)*Ho(z)**3)/z + 9*z*H1h(z)*Ho(z)**3 - 
     -  9*z**2*H1h(z)*Ho(z)**3 + 36*Hm1(z)*Ho(z)**3 + (18*Hm1(z)*Ho(z)**3)/z + 18*z*Hm1(z)*Ho(z)**3 + 18*z**2*Hm1(z)*Ho(z)**3 - 
     -  (18*Hm1(z)*Ho(z)**3)/(1 + z) - (9*Ho(z)**4)/2. + (8*Nf*Ho(z)**4)/27. + (9*Ho(z)**4)/(8.*(1 - z)) + (63*z*Ho(z)**4)/8. - 
     -  (383*Nf*z*Ho(z)**4)/864. - (9*z**2*Ho(z)**4)/4. + (9*Ho(z)**4)/(8.*(1 + z)) + (1197*Zeta(3))/8. + (163*Nf*Zeta(3))/12. - (Nf**2*Zeta(3))/9. - 
     -  (1287*Zeta(3))/(8.*z) - (323*Nf*Zeta(3))/(108.*z) + 99*z*Zeta(3) - (749*Nf*z*Zeta(3))/36. - (Nf**2*z*Zeta(3))/9. + 198*z**2*Zeta(3) + 
     -  (116*Nf*z**2*Zeta(3))/27. + 81*H1h(z)*Zeta(3) - (81*H1h(z)*Zeta(3))/(2.*z) - (81*z*H1h(z)*Zeta(3))/2. + (81*z**2*H1h(z)*Zeta(3))/2. - 
     -  162*Hm1(z)*Zeta(3) - (81*Hm1(z)*Zeta(3))/z - 81*z*Hm1(z)*Zeta(3) - 81*z**2*Hm1(z)*Zeta(3) + (81*Hm1(z)*Zeta(3))/(1 + z) + 
     -  (19*Nf*Ho(z)*Zeta(3))/9. - (189*Ho(z)*Zeta(3))/(4.*(1 - z)) - (27*Ho(z)*Zeta(3))/(2.*z) - (135*z*Ho(z)*Zeta(3))/2. - 
     -     (89*Nf*z*Ho(z)*Zeta(3))/18. + 81*z**2*Ho(z)*Zeta(3) - (135*Ho(z)*Zeta(3))/(4.*(1 + z)) + (Log(1 - z)*(-54*Hm3(z) + (81*Zeta(3))/2.))/(1 - z)
     - -(Log(1 - z)*(-54*Hm3(z) + (81*Zeta(3))/2.))/(1 - z)
      return
      end
